---
include:
  - .gitlab-ci/base_docker_stage.yml
  - .gitlab-ci/base_register_kaniko.yml

workflow:
  rules:
    # Skip GitHub pull requests pipelines
    - if: $CI_PIPELINE_SOURCE == 'external_pull_request_event'
      when: never
    # Otherwise include the job and set to run normally
    - when: always

stages:
  # - Install
  - Lint
  # - Code Quality
  - Registration
  - Deploy

variables:
  GIT_STRATEGY: fetch
  GIT_DEPTH: 5

.autodevops_hadolint:
  extends:
    - .base_docker_hadolint
  stage: Lint

.autodevops_register_kaniko_image:
  extends:
    - .base_register_kaniko
  stage: Registration
  variables:
    CONTEXT: .
    IMAGE_NAME: $CI_PROJECT_NAME

.autodevops_develop:
  stage: Deploy
  image: estudosdevops/argocd-cli:v1
  before_script:
    - argocd login $ARGO_URL --username $ARGO_USER --password $ARGO_PASS --grpc-web
    - argocd repo add $CI_REPOSITORY_URL
    - argocd proj create $CI_PROJECT_NAME -d "*,*" -s "*" --allow-cluster-resource "*/*"
  script:
    - argocd app create $CI_PROJECT_NAME --upsert --project $CI_PROJECT_NAME --dest-server $K8S_PROD --repo $CI_REPOSITORY_URL --path .argocd/develop
    - argocd app set $CI_PROJECT_NAME --sync-policy automated --auto-prune --self-heal
    - argocd app get $CI_PROJECT_NAME
  # only:
  # - develop
Develop:
  extends: .autodevops_develop
